
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[转载] 彻底学习STL中的Allocator / 憋错料</title>

    <meta name="description" content="[转载] 彻底学习STL中的Allocator 原文: http://cissco.iteye.com/blog/379093 帮助我们理解allocator的原理 Allocator是C++语言标准库中最神秘的部分之一.它们很少被显式使用,标准也没有明确出它们应该在什么时候被使用.今天的allocator与最初的STL建议非常不同,在此过程中还存在着另外两个设计--这两个都依赖于语言的一些特性,而直到最近才在很少的几个编译器上可用.对allocator的功能,标准似乎在一些方面追加了承诺,而在另外一些方面撤销了承诺. 这篇专栏文章将讨论你能">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">[转载] 彻底学习STL中的Allocator</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>原文:&nbsp;http://cissco.iteye.com/blog/379093</p>
<p>帮助我们理解allocator的原理</p>
<p>Allocator是C++语言标准库中最神秘的部分之一。它们很少被显式使用，标准也没有明确出它们应该在什么时候被使用。今天的allocator与最初的STL建议非常不同，在此过程中还存在着另外两个设计－－这两个都依赖于语言的一些特性，而直到最近才在很少的几个编译器上可用。对allocator的功能，标准似乎在一些方面追加了承诺，而在另外一些方面撤销了承诺。</p>
<p>这篇专栏文章将讨论你能用allocator来做什么以及如何定义一个自己的版本。我只会讨论C++标准所定义的allocator：引入准标准时代的设计，或试图绕过有缺陷的编译器，只会增加混乱。</p>
<h3>什么时候不使用Allocator</h3>
<p>C++标准中的Allocator分成两块：一个通用需求集（描述于&sect; 20.1.5(表 32)），和叫std::allocator的class（描述于&sect;20.4.1）。如果一个class满足表32的需求，我们就称它为一个allocator。std::allocator类满足那些需求，因此它是一个allocator。它是标准程序库中的唯一一个预先定义allocator类。</p>
<p>每个 C++程序员都已经知道动态内存分配：写下new X来分配内存和创建一个X类型的新对象，写下delete p来销毁p所指的对象并归还其内存。你有理由认为allocator会使用new和delete－－但它们没有。（C++标准将::operator new()描述为&ldquo;allocation function&rdquo;，但很奇怪，allocator并不是这样的。）</p>
<p>有关allocator的最重要的事实是它们只是为了一个目的：封装STL容器在内存管理上的低层细节。你不应该在自己的代码中直接调用allocator的成员函数，除非正在写一个自己的STL容器。你不应该试图使用allocator来实现operator new[]；这不是allocator该做的。 如果你不确定是否需要使用allocator，那就不要用。</p>
<p>allocator是一个类,有着叫allocate()和deallocate()成员函数（相当于malloc和free）。它还有用于维护所分配的内存的辅助函数和指示如何使用这些内存的typedef（指针或引用类型的名字）。如果一个STL容器使用用户提供的allocator来分配它所需的所有内存(预定义的STL容器全都能这么做；他们都有一个模板参数，其默认值是std::allocator)，你就能通过提供自己的allocator来控制它的内存管理。</p>
<p>这种柔性是有限制的：仍然由容器自己决定它将要申请多少内存以及如何使用它们。在容器申请更多的内存时，你能控制它调用那个低层函数，但是你不能通过使用allocator来让一个vector行动起来像一个deque一样。虽然如此，有时候，这个受限的柔性也很有用。比如，假设你有一个特殊的fast_allocator，能快速分配和释放内存（也许通过放弃线程安全性，或使用一个小的局部堆），你能通过写下std::list&lt;T, fast_allocator&lt;T&gt; &gt;而不是简单的std::list&lt;T&gt;来让标准的list使用它。</p>
<p>如果这看起来对你很陌生，那就对了。没有理由在常规代码中使用allocator的。</p>
<h3>定义一个Allocator</h3>
<p>关于allocator的这一点你已经看到了：它们是模板。Allocator，和容器一样，有value_type，而且allocator的value_type必须要匹配于使用它的容器的value_type。这有时会比较丑陋：map的value_type相当复杂，所以显式调用allocator的map看起来象这样的，std::map&lt;K，V, fast_allocator&lt;std::pair&lt;const K, V&gt; &gt; &gt;。(像往常一样，typedef会对此有帮助。)</p>
<p>以一个简单的例子开始。根据C++标准，std::allocator构建在::operator new()上。如果你正在使用一个自动化内存使用跟踪工具，让std::allocator更简单些会更方便。我们可以用malloc()代替::operator new()，而且我们也不考虑（在好的std::allocator实作中可以找到的）复杂的性能优化措施。我们将这个简单的allocator叫作malloc_allocator 。</p>
<p>既然malloc_allocator的内存管理很简单，我们就能将重点集中在所有STL的allocator所共有的样板上。首先，一些类型：allocator是一个类模板，它的实例专为某个类型T分配内存。我们提供了一序列的typedef，以描述该如何使用此类型的对象：value_type指T本身，其它的则是有各种修饰字的指针和引用。</p>
<p>Cpp代码</p>
<ol>
<li>template&nbsp;&lt;class&nbsp;T&gt;&nbsp;class&nbsp;malloc_allocator</li>
<li>{</li>
<li>public:</li>
<li>typedef&nbsp;T&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value_type;</li>
<li>typedef&nbsp;value_type*&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;pointer;</li>
<li>typedef&nbsp;const&nbsp;value_type*&nbsp;const_pointer;</li>
<li>typedef&nbsp;value_type&amp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;reference;</li>
<li>typedef&nbsp;const&nbsp;value_type&amp;&nbsp;const_reference;</li>
<li>typedef&nbsp;std::size_t&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;size_type;</li>
<li>typedef&nbsp;std::ptrdiff_t&nbsp;&nbsp;&nbsp;&nbsp;difference_type;</li>
<li>...</li>
<li>};</li>
</ol>
<p>这些类型与STL容器中的很相似，这不是巧合：容器类常常直接从它的allocator提取这些类型。</p>
<p>为什么有这么多的typedef？你可能认为pointer是多余的：它就是value_type *。绝大部份时候这是对的，但你可能有时候想定义非传统的allocator，它的pointer是一个pointer-like的class，或非标的厂商特定类型value_type __far *；allocator是为非标扩展提供的标准hook。不寻常的pointer类型也是存在address()成员函数的理由，它在malloc_allocator中只是operator &amp;()的另外一种写法：</p>
<p>Cpp代码</p>
<ol>
<li>template&nbsp;&lt;class&nbsp;T&gt;&nbsp;class&nbsp;malloc_allocator</li>
<li>{</li>
<li>public:</li>
<li>pointer&nbsp;address(reference&nbsp;x)&nbsp;const&nbsp;{&nbsp;return&nbsp;&amp;x;&nbsp;}</li>
<li>const_pointer&nbsp;address(const_reference&nbsp;x)&nbsp;const&nbsp;{</li>
<li>return&nbsp;&amp;x;</li>
<li>}</li>
<li>...</li>
<li>};</li>
</ol>
<p>现在我们能开始真正的工作：allocate()和deallocate()。它们很简单，但并不十分象malloc()和free()。我们传给allocate()两个参数：我们正在为其分派空间的对象的数目(max_size返回可能成功的最大请求值)，以及可选的一个地址值（可以被用作一个位置提示）。象malloc_allocator这样的简单的allocator没有利用那个提示，但为高性能而设计的allocator可能会利用它。返回值是一个指向内存块的指针，它足以容纳n个value_type类型的对象并有正确的对齐。</p>
<p>我们也传给deallocate()两个参数：当然一个是指针，但同样还有一个元素计数值。容器必须自己掌握大小信息；传给allocate和deallocate的大小参数必须匹配。同样，这个额外的参数是为效率而存在的，而同样，malloc_allocator不使用它。</p>
<p>Cpp代码</p>
<ol>
<li>template&nbsp;&lt;class&nbsp;T&gt;&nbsp;class&nbsp;malloc_allocator</li>
<li>{</li>
<li>public:</li>
<li>pointer&nbsp;allocate(size_type&nbsp;n,&nbsp;const_pointer&nbsp;=&nbsp;0)&nbsp;{</li>
<li>void*&nbsp;p&nbsp;=&nbsp;std::malloc(n&nbsp;*&nbsp;sizeof(T));</li>
<li>if&nbsp;(!p)</li>
<li>throw&nbsp;std::bad_alloc();</li>
<li>return&nbsp;static_cast&lt;pointer&gt;(p);</li>
<li>}</li>
<li>void&nbsp;deallocate(pointer&nbsp;p,&nbsp;size_type)&nbsp;{</li>
<li>std::free(p);</li>
<li>}</li>
<li>size_type&nbsp;max_size()&nbsp;const&nbsp;{</li>
<li>return&nbsp;static_cast&lt;size_type&gt;(-1)&nbsp;/&nbsp;sizeof(value_type);</li>
<li>}</li>
<li>...</li>
<li>};</li>
</ol>
<p>allocate()和deallocate()成员函数处理的是未初始化的内存，它们不构造和销毁对象。语句a.allocate(1)更象malloc(sizeof(int))而不是new int。在使用从allocate()获得的内存前，你必须在这块内存上创建对象；在通过deallocate()归还内存前，你需要销毁那些对象。</p>
<p>C++语言提供一个机制以在特定的内存位置创建对象：placement new。如果你写下new(p) T(a, b)，那么你正在调用T的构造函数产生一个新的对象，一如你写的new T(a, b)或 T t(a, b)。区别是当你写new(p) T(a, b)，你指定了对象被创建的位置：p所指向的地址。(自然，p必须指向一块足够大的内存，而且必须是未被使用的内存；你不能在相同的地址构建两个不同的对象。)。你也可以调用对象的析构函数，而不释放内存，只要写p-&gt;~T()。</p>
<p>这些特性很少被使用，因为通常内存的分配和初始化是一起进行的：使用未初始化的内存是不方便的和危险的。你需要如此低层的技巧的很少几处之一就是你在写一个容器类，于是allocator将内存的分配与初始化解耦。成员函数construct()调用placement new，而且成员函数destory()调用析构函数。</p>
<p>Cpp代码</p>
<ol>
<li>template&nbsp;&lt;class&nbsp;T&gt;&nbsp;class&nbsp;malloc_allocator</li>
<li>{</li>
<li>public:</li>
<li>void&nbsp;construct(pointer&nbsp;p,&nbsp;const&nbsp;value_type&amp;&nbsp;x)&nbsp;{</li>
<li>new(p)&nbsp;value_type(x);</li>
<li>}</li>
<li>void&nbsp;destroy(pointer&nbsp;p)&nbsp;{&nbsp;p-&gt;~value_type();&nbsp;}</li>
<li>...</li>
<li>};</li>
</ol>
<p>(为什么allocator有那些成员函数，什么时候容器可以直接使用placement new？一个理由是要隐藏笨拙的语法，而另一个是如果写一个更复杂的allocator时你可能想在构造和销毁对象时construct()和destroy()还有其它一些副作用。比如，allocator可能维护一个所有当前活动对象的日志。)</p>
<p>这些成员函数没有一个是static的，因此，容器在使用allocator前做的第一件事就是创建一个allocator对象－－也就是说我们应该定义一些构造函数。但是，我们不需要赋值运算：一旦容器创建了它的allocator，这个allocator就从没想过会被改变。表32中的对allocator的需求没有包括赋值。只是基于安全，为了确保没人偶然使用了赋值运算，我们将禁止掉这个可能自动生成的函数。</p>
<p>Cpp代码</p>
<ol>
<li>template&nbsp;&lt;class&nbsp;T&gt;&nbsp;class&nbsp;malloc_allocator</li>
<li>{</li>
<li>public:</li>
<li>malloc_allocator()&nbsp;{}</li>
<li>malloc_allocator(const&nbsp;malloc_allocator&amp;)&nbsp;{}</li>
<li>~malloc_allocator()&nbsp;{}</li>
<li>private:</li>
<li>void&nbsp;operator=(const&nbsp;malloc_allocator&amp;);</li>
<li>...</li>
<li>};</li>
</ol>
<p>这些构造函数实际上没有做任何事，因为这个allocator不需要初始化任何成员变量。基于同样的理由，任意两个malloc_allocator都是可互换的；如果a1和a2的类型都是malloc_allocator&lt;int&gt;，我们可以自由地通过a1来allocate()内存然后通过a2来deallocate()它。我们因此定义一个比较操作以表明所有的malloc_allocator对象是等价的：</p>
<p>Cpp代码</p>
<ol>
<li>template&nbsp;&lt;class&nbsp;T&gt;</li>
<li>inline&nbsp;bool&nbsp;operator==(const&nbsp;malloc_allocator&lt;T&gt;&amp;,</li>
<li>const&nbsp;malloc_allocator&lt;T&gt;&amp;)&nbsp;{</li>
<li>return&nbsp;true;</li>
<li>}</li>
<li>template&nbsp;&lt;class&nbsp;T&gt;</li>
<li>inline&nbsp;bool&nbsp;operator!=(const&nbsp;malloc_allocator&lt;T&gt;&amp;,</li>
<li>const&nbsp;malloc_allocator&lt;T&gt;&amp;)&nbsp;{</li>
<li>return&nbsp;false;</li>
<li>}</li>
</ol>
<p>你会期望一个allocator，它的不同对象是不可替换的吗？当然－－但很难提供一个简单而有用的例子。一种明显的可能性是内存池。它对大型的C程序很常见，从几个不同的位置（&ldquo;池&rdquo;）分配内存，而不是什么东西都直接使用malloc()。这样做有几个好处，其一是it only takes a single function call to reclaim all of the memory associated with a particular phase of the program。 使用内存池的程序可能定义诸如mempool_Alloc和mempool_Free这样的工具函数，mempol_Alloc(n, p)从池p中分配n个字节。很容易写出一个mmepool_alocator以匹配这样的架构：每个mempool_allocator对象有一个成员变量以指明它绑定在哪个池上，而mempool_allocator::allocate()将调用mempool_Alloc()从相应的池中获取内存。[注1]</p>
<p>最后，我们到了allocator的定义体中一个微妙的部份：在不同的类型之间映射。问题是，一个allocator类，比如malloc_allocator&lt;int&gt;，全部是围绕着单个value_type构建的：malloc_allocator&lt;int&gt;::pointer是int*，malloc_allocator&lt;int&gt;().allocate(1)返回足够容纳一个int对象的内存，等等。然而，通常，容器类使用malloc_allocator可能必须处理超过一个类型。比如，一个list类，不分配int对象；实际上，它分配list node对象。(我们将在下一段落研究细节。)于是，当你创建一个std::list&lt;int, malloc_allocator&lt;int&gt; &gt;时，list必须将malloc_allocator&lt;int&gt;转变成为处理list_node类型的malloc_allocator。</p>
<p>这个机制称为重绑定，它有二个部份。首先，对于给定的一个value_type是X1的allocator类型A1，你必须能够写出一个allocator类型A2，它与A1完全相同，除了value_type是X2。其次，对于给定的A1类型的对象a1，你必须能够创建一个等价的A2类型对象a2。这两部分都使用了成员模板，这也就是allocator不能被老的编译器支持，或支持得很差的原因。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-21 13:02:44 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>[转载] 彻底学习STL中的Allocator的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLOODE4.html" rel="bookmark">Gym - 100989D 题学习stl中的set&amp;lt&semi;pair&amp;lt&semi;int &comma;int &amp;gt&semi; &amp;gt&semi;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目网址链接:https://vjudge.net/problem/387095/origin 题目大意:给出桌子数和桌子容纳人数,给出几条操作,操作如下:给出顾客人数,问是否有能容纳顾客且桌子标号和桌子容纳人数与顾客人数差值同时最小的桌子,有即输出桌子编号,没有输出-1:期间会有顾客离开,给出离开的桌子编号. 在做题之前,先学习STL中的set:以集合形式从小到大排列set中的元素. 先给出几个大牛博客链接: https://www.cnblogs.com/zyxStar/p/4542835.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyQjGAM.html" rel="bookmark">STL中关于map和set的四个问题？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				STL map和set的使用虽不复杂,但也有一些不易理解的地方,如: # 为何map和set的插入删除效率比用其他序列容器高? # 为何每次insert之后,以前保存的iterator不会失效? # 为何map和set不能像vector一样有个reserve函数来预分配数据? # 当数据元素增多时(10000到20000个比较),map和set的插入和搜索速度变化如何? 或许有得人能回答出来大概原因,但要彻底明白,还需要了解STL的底层数据结构. C++ STL 之所以得到广泛的赞誉,也被很多人			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Jz7BQ4.html" rel="bookmark">STL中的内存分配器原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题记:内存管理一直是C/C++程序的红灯区.关于内存管理的话题,大致有两类侧重点,一类是内存的正确使用,例如C++中new和delete应该成对出现,用RAII技巧管理内存资源,auto_ptr等方面,很多C/C++书籍中都使用技巧的介绍.另一类是内存管理的实现,如linux内核的slab分配器,STL中的allocator实现,以及一些特定于某种对象的内存管理等.最近阅读了一些内存管理实现方面的资料和源码,整理了一下,汇编成一个系列介绍一些常用的内存管理策略. 1. STL容器简介 STL提供			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MorYAb4.html" rel="bookmark">STL  中make&lowbar;heap学习</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				STL中make_heap 的接口为: default (1) template &lt;class RandomAccessIterator&gt; void make_heap (RandomAccessIterator first, RandomAccessIterator last); custom (2) template &lt;class RandomAccessIterator, class Compare&gt; void make_heap (RandomAccessIterator			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZbzDq3.html" rel="bookmark">C&plus;&plus; STL中哈希表 hash&lowbar;map介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				过map吧?map提供一个很常用的功能,那就是提供key-value的存储和查找功能.例如,我要记录一个人名和相应的存储,而且随时增加,要快速查找和修改: 岳不群-华山派掌门人,人称君子剑张三丰-武当掌门人,太极拳创始人东方不败-第一高手,葵花宝典... 这些信息如果保存下来并不复杂,但是找起来比较麻烦.例如我要找&quot;张三丰&quot;的信息,最傻的方法就是取得所有的记录,然后按照名字一个一个比较.如果要速度快,就需要把这些记录按照字母顺序排列,然后按照二分法查找.但是增加记录的时候同时需要保持记			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lkDkNM.html" rel="bookmark">C&plus;&plus;的标准模板库STL中实现的数据结构之顺序表vector的分析与使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要 本文主要借助对C++的标准模板库STL中实现的数据结构的学习和使用来加深对数据结构的理解.即联系数据结构的理论分析和详细的应用实现(STL),本文是系列总结的第一篇,主要针对线性表中的顺序表(动态数组)STL vector进行分析和总结. 引言 因为前段时间对台大的机器学习基石和技法课程进行了学习,发如今详细的实现中经常涉及到各种类型的数据结构,比方线性表.二叉树.图等,在使用这些数据结构时感到有些吃力.主要是对一些主要的数据结构理解的不够.所以趁着暑假假期.近期一段时间总会抽出时间复习一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmQYRQM.html" rel="bookmark">学习STL -- 向量vector</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在STL中向量vector是使用数组的形式实现的,因此向量具有顺序表的所有特点,可以快速随机存取任意元素.向量是同一种数据类型的对象的集合,每个对象根据其位置有一个整数索引值与其对应,类似于数组.与定义数组不同,向量在实例化是不需要声明长度,标准库负责管理和储存元素相关的内存,不用担心长度不够. vector容器中的元素是连续存放的,当容器中增加一个新元素的时候,如果原来的存储空间刚好被用完,那么系统需要重新申请一块更大的连续存储空间,把原来的元素复制到新的空间,并在最后添加新元素,最后再撤销久			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pOZV83.html" rel="bookmark">C&plus;&plus; STL中Map的按Key排序跟按Value排序（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C++ STL中Map的按Key排序和按Value排序 map是用来存放&lt;key, value&gt;键值对的数据结构,可以很方便快速的根据key查到相应的value.假如存储学生和其成绩(假定不存在重名,当然可以对重名加以区 分),我们用map来进行存储就是个不错的选择. 我们这样定义,map&lt;string, int&gt;,其中学生姓名用string类型,作为Key:该学生的成绩用int类型,作为value.这样一来,我们可以根据学生姓名快速的查找到 他的成绩. 但是,我们除了希望能够查询			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/W0jXdD4.html" rel="bookmark">C&plus;&plus; STL中Map的按Key排序和按Value排序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文  http://blog.csdn.net/iicy266/article/details/11906189 map是用来存放&lt;key, value&gt;键值对的数据结构,可以很方便快速的根据key查到相应的value.假如存储学生和其成绩(假定不存在重名,当然可以对重名加以区分),我们用map来进行存储就是个不错的选择. 我们这样定义,map&lt;string, int&gt;,其中学生姓名用string类型,作为Key:该学生的成绩用int类型,作为value.这样一来,我们可以根据学			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n4AEN54.html" rel="bookmark" class="title">ACM比赛经验</a>
					<div>
						ACM比赛经验: 推荐此篇文章打印,与模板放在一起. 1. 比赛中评测会有些慢,偶尔还会碰到隔10分钟以上才返回结果的情况,这段时间不能等结果,必须开工其他题,如果WA,两道题同时做.交完每道题都要先 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMmeGVM.html" rel="bookmark" class="title">阿里云CentOS Linux服务器上搭建邮件服务器遇到的问题</a>
					<div>
						参考文章: 阿里云CentOS Linux服务器上用postfix搭建邮件服务器 Linux系统下邮件服务器的搭建(Postfix+Dovecot) 本来想自己搭建邮件服务器,但是看到一篇资料表示阿里 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n4AgXK0.html" rel="bookmark" class="title">Django之路 - 项目实战之&amp;lt&semi;教育行业CRM开发&amp;gt&semi;</a>
					<div>
						本节内容 业务痛点分析 项目需求讨论 使用场景分析 表结构设计 业务痛点分析 我2013年刚加入老男孩教育的时候,学校就一间教室,2个招生老师,招了学生后,招生老师就在自己的excel表里记录一下,每 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0eKjE4.html" rel="bookmark" class="title">谓词&lpar;NSPredicate&rpar;</a>
					<div>
						OC中的谓词操作是针对于数组类型的,他就好比数据库中的查询操作,数据源就是数组,这样的好处是我们不需要编写很多代码就可以去操作数组,同时也起到过滤的作用,我们可以编写简单的谓词语句,就可以从数组中过滤 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGGjAoM.html" rel="bookmark" class="title">linux 目录结构</a>
					<div>
						命令名称 描述   /etc/hosts 定义:把主机名解析为IP地址 格式:10.0.0.200   www.taobao.com /etc/fstab 定义:(开机时磁盘分区与目录的挂载关系) f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXp5l3.html" rel="bookmark" class="title">网站  ping  dns  等检测</a>
					<div>
						360奇测: http://ce.cloud.360.cn      17ce测: http://www.17ce.com  站长工具:http://ping.chinaz.com 非常好::推荐指数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVwqew0.html" rel="bookmark" class="title">UVa11426 GCD - Extreme &lpar;II&rpar;</a>
					<div>
						见http://www.cnblogs.com/SilverNebula/p/6280370.html II的数据范围是I的20倍. 但是做I时用的O(n)+O(nlogn)+O(n)的算法足够了.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmlwGY4.html" rel="bookmark" class="title">图像预处理</a>
					<div>
						图像预处理的多个方法: http://blog.csdn.net/u014365862/article/details/51519154 图像预处理方法及实例(应用): http://wenku.ba ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8x8N0.html" rel="bookmark" class="title">Java开发中经典的小实例-&lpar;if&lpar;参数&rpar;&lbrace;&rcub;else&lbrace;&rcub;&rpar;</a>
					<div>
						import java.util.Scanner; public class Calculate { public static void main(String[] args) {        / ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35bOLj4.html" rel="bookmark" class="title">vsphere Fault Tolerance 故障容错</a>
					<div>
						Vsphere HA 与vsphere FT的对比 HA:通过在主机出现故障的时候重新启动虚拟机来为虚拟机提供基本级别的保护,提供快速恢复,减少非计划停机时间. 说明在虚拟机重新启动的时候有中断时间, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MP8jGDM.html" rel="bookmark" class="title">SQLite XXTea加密学习</a>
					<div>
						这几天优化数据库读写,移植了xxtea加密到最新的数据库sqlite 3.12.2里,一些好文章放在这里.移植后,数据库读写性能异常优秀! 这几天又发现,数据库还是发生了无法写入情况,数据库崩溃掉了. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RGBjy3.html" rel="bookmark" class="title">C&plus;&plus;多线程の条件变量</a>
					<div>
						如果有一个队列,方法一和方法二:方法一是生产者,方法二是消费者: 两者不停的相互等待,加减锁,为了减少不必要的等待,我们可以使用条件变量, 条件的变量的第二个参数的加入可以控制多个线程的&quot;消 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lW5RoM.html" rel="bookmark" class="title">探讨JavaScript的事件冒泡</a>
					<div>
						JavaSciprt事件中有两个很重要的特性:事件冒泡以及目标元素. 当一个元素上的事件被触发的时候,比如说鼠标点击了一个按钮,同样的事件将会在那个元素的所有祖先元素中被触发.这一过程被称为事件冒泡: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzAQBk4.html" rel="bookmark" class="title">JAVA命名、注释规范</a>
					<div>
						一.命名规范 1. 项目名全部小写 2. 包名全部小写(除非部分是缩写) 3. 类名首字母大写,如果类名由多个单词组成,每个单词的首字母都要大写. 如:public class MyFirstClas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bpmPp4.html" rel="bookmark" class="title">iOS之分别使用代码和storyboard、xib为控件设置圆角（以按钮为例）</a>
					<div>
						首先我们看一下代码是如何给按钮设置圆角的: 我们再来看看如何在storyboard或xib中给按钮设置圆角: 1.在storyboard或xib中添加按钮后,设置标题和背景色,做好约束: 2.点击 S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OnkmX0.html" rel="bookmark" class="title">黑马程序员-----安卓常用uri</a>
					<div>
						content://com.android.contacts/contacts 对应数据库表中contacts表 用于获得联系人Id  关键字&quot;_id&quot; content://com ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xa9ND3.html" rel="bookmark" class="title">Java并发编程实践之对象的组合</a>
					<div>
						---恢复内容开始--- 1 对象组合的目的 将一些现有的线程安全类组合成更大的组件,也是线程安全的: 1.1 构造线程安全的类需要考虑: 构成对象状态的所有变量: 对象变量的不变性条件(对象的变量都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38pQ7W3.html" rel="bookmark" class="title">第五章 引用类型 基本包装类型</a>
					<div>
						为了便于操作基本类型值,ECMAScript 提供了3 个特殊的引用类型:Boolean.Number 和String.实际上,每当读取一个基本类型值的时候,后台就会创建一个对应的基本包装类型的对象, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZaJom0.html" rel="bookmark" class="title">分治之归并排序模版</a>
					<div>
						1 /* 2 归并排序模版 3 对n个数进行排序 4 时间复杂度:O(nlogn); 5 利用分治思想,对比左半边和右边边放入一个暂时的数组进行排序 6 */ 7 #include &lt;iostr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49ODeA0.html" rel="bookmark" class="title">MFC中CListCtrl控件的使用方法</a>
					<div>
						定义一个派生类CViewList 派生于CListCtrl 在要包含该控件的类(CView)中定义一个CViewList类型的变量 CViewList m_wndListView; 在CView响应的 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
